<?php
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

// BEGIN ENQUEUE PARENT ACTION
// AUTO GENERATED - Do not modify or remove comment markers above or below:
         
if ( !function_exists( 'child_theme_configurator_css' ) ):
    function child_theme_configurator_css() {
        wp_enqueue_style( 'chld_thm_cfg_child', trailingslashit( get_stylesheet_directory_uri() ) . 'style.css');
        wp_enqueue_script( 'chld_thm_custom_scripts', trailingslashit( get_stylesheet_directory_uri() ) . 'assets/js/scripts.js');
    }
endif;
add_action( 'wp_enqueue_scripts', 'child_theme_configurator_css', 10 );

function PREFIX_remove_scripts() {
    wp_dequeue_style( 'twenty-twenty-one-style' );
    wp_deregister_style( 'twenty-twenty-one-style');
}
add_action( 'wp_enqueue_scripts', 'PREFIX_remove_scripts', 20);
// END ENQUEUE PARENT ACTION

function currentyear(){
    return date('Y');
}
add_shortcode('year','currentyear');

register_sidebar( array(
    'name' => 'Primary Sidebar',
    'id' => 'primary-sidebar',
    'description' => 'The main sidebar appears on the right on each page except the front page template',
    'before_widget' => '<aside id="%1$s" class="widget %2$s">',
    'after_widget' => '</aside>',
    'before_title' => '<h3 class="widgettitle-">',
    'after_title' => '</h3>',
));

add_action( 'wp_footer' , 'custom_quantity_fields_script' );
function custom_quantity_fields_script(){ ?>
    <script type='text/javascript'>
    jQuery( function( $ ) {
        if ( ! String.prototype.getDecimals ) {
            String.prototype.getDecimals = function() {
                var num = this,
                    match = ('' + num).match(/(?:\.(\d+))?(?:[eE]([+-]?\d+))?$/);
                if ( ! match ) {
                    return 0;
                }
                return Math.max( 0, ( match[1] ? match[1].length : 0 ) - ( match[2] ? +match[2] : 0 ) );
            }
        }
        // Quantity "plus" and "minus" buttons
        $( document.body ).on( 'click', '.plus, .minus', function() {
            var $qty        = $( this ).closest( '.quantity' ).find( '.qty'),
                currentVal  = parseFloat( $qty.val() ),
                max         = parseFloat( $qty.attr( 'max' ) ),
                min         = parseFloat( $qty.attr( 'min' ) ),
                step        = $qty.attr( 'step' );

            // Format values
            if ( ! currentVal || currentVal === '' || currentVal === 'NaN' ) currentVal = 0;
            if ( max === '' || max === 'NaN' ) max = '';
            if ( min === '' || min === 'NaN' ) min = 0;
            if ( step === 'any' || step === '' || step === undefined || parseFloat( step ) === 'NaN' ) step = 1;

            // Change the value
            if ( $( this ).is( '.plus' ) ) {
                if ( max && ( currentVal >= max ) ) {
                    $qty.val( max );
                } else {
                    $qty.val( ( currentVal + parseFloat( step )).toFixed( step.getDecimals() ) );
                }
            } else {
                if ( min && ( currentVal <= min ) ) {
                    $qty.val( min );
                } else if ( currentVal > 0 ) {
                    $qty.val( ( currentVal - parseFloat( step )).toFixed( step.getDecimals() ) );
                }
            }

            // Trigger change event
            $qty.trigger( 'change' );
            <?php if(is_cart()){ ?>
                $("#update_cart").removeAttr('disabled');
                $('#update_cart').trigger('click');
                setTimeout(function(){
                    $('#cartreviewtab').trigger('click');
                    $('.nav-tabs > .active').prev('li').removeClass('disabled');
                }, 2000);
            <?php } ?>
        });
    });
    </script>
    <?php
}

function get_home_woo_categories(){
    ob_start();
    $args = array('taxonomy' => 'product_cat', 'number' => 9, 'parent' => 0, 'hide_empty' => 0, 'exclude' => 161);
    $all_categories = get_categories($args);
    $count = 0;
    if(!empty($all_categories)){ ?>
        <div class="woo-category-lists">
            <div class="lists-inner">
                <?php foreach ($all_categories as $cat){ $count++;
                    $category_id = $cat->term_id;
                    $thumbnail_id = get_term_meta( $category_id, 'thumbnail_id', true );
                    $category_img = wp_get_attachment_url($thumbnail_id, 'full'); ?>

                    <?php if($count == 1){ ?><div class="left-part"><?php } ?>
                        <div class="category-list">
                            <div class="cate-image">
                                <a href="<?=get_term_link($cat->slug, 'product_cat')?>"><img src="<?=$category_img?>"></a>
                            </div>
                            <div class="cate-title">
                                <a href="<?=get_term_link($cat->slug, 'product_cat')?>"><?=$cat->name?></a>        
                            </div>
                        </div>
                    <?php if($count == 4){ ?></div><div class="right-part"><?php } ?>
                    <?php if($count == 7){ ?></div><div class="bottom-part"><?php } ?>
                    <?php if($count == 9){ ?></div><?php $count = 0; } ?>
                <?php } ?>
            </div>
        </div>
    <?php } ?>
    <?php return ob_get_clean();
}
add_shortcode('Woo_Home_Categories','get_home_woo_categories');

/*Woo hooks*/
add_filter('woocommerce_product_description_heading', '__return_null' );
add_filter('woocommerce_product_additional_information_heading', '__return_null' );
remove_action( 'woocommerce_before_main_content','woocommerce_breadcrumb', 20, 0);
add_action( 'woocommerce_before_single_product_summary', 'woocommerce_breadcrumb', 5 );
add_action('woocommerce_before_shop_loop_item_title', 'woocommerce_template_loop_product_link_close', 11);
add_action('woocommerce_shop_loop_item_title', 'woocommerce_template_loop_product_link_open', 6);
add_filter( 'woocommerce_subcategory_count_html', '__return_null' );
add_filter( 'woocommerce_product_subcategories_hide_empty', '__return_false' );

add_action( 'woocommerce_before_single_product', function(){
    echo do_shortcode('[elementor-template id="245"]');
}, 1 );

function display_product_category(){
    global $post;
    $terms = get_the_terms( $post->ID, 'product_cat' );
    if(!is_front_page()){
        foreach ($terms as $term) {
            echo '<div class="category-lists"><a href="'.get_term_link( $term->term_id ).'">'.$term->name.'</a></div>';
            break;
        }
    }
}
add_action('woocommerce_shop_loop_item_title', 'display_product_category', 5);

add_filter( 'woocommerce_single_product_carousel_options', 'wcsuccess_woo_flexslider_navigation' );
function wcsuccess_woo_flexslider_navigation( $options ) {
    $options['directionNav'] = true;
    return $options;
}

add_filter( 'woocommerce_email_styles', 'custom_woocommerce_email_styles' );
function custom_woocommerce_email_styles( $css ) {
$css .= "#template_header_image { background-color: #000000; padding: 32px !important;}";
$css .= "@media screen and (max-width: 600px) {#template_header_image, #header_wrapper {padding: 25px !important;}}";
return $css;
}

add_action( 'woocommerce_register_form_start', 'woo_add_register_form_field' );
function woo_add_register_form_field(){
    woocommerce_form_field(
        'regi_first_name',
        array(
            'type'        => 'text',
            'required'    => true,
            'label'       => 'First name'
        ),
        ( isset( $_POST[ 'regi_first_name' ] ) ? $_POST[ 'regi_first_name' ] : '' )
    );
    woocommerce_form_field(
        'regi_last_name',
        array(
            'type'        => 'text',
            'required'    => true,
            'label'       => 'Last name'
        ),
        ( isset( $_POST[ 'regi_last_name' ] ) ? $_POST[ 'regi_last_name' ] : '' )
    );
}

add_action( 'woocommerce_register_post', 'woo_validate_register_fields', 10, 3 );
function woo_validate_register_fields( $username, $email, $errors ) {
    if( empty( $_POST[ 'regi_first_name' ] ) ) {
        $errors->add( 'regi_first_name_error', 'First name is a required field.' );
    }
    if( empty( $_POST[ 'regi_last_name' ] ) ) {
        $errors->add( 'regi_last_name_error', 'Last name is a required field.' );
    }
}

add_action( 'woocommerce_created_customer', 'woo_save_register_fields' );
function woo_save_register_fields( $customer_id ){
    if ( isset( $_POST[ 'regi_first_name' ] ) ) {
        update_user_meta( $customer_id, 'first_name', wc_clean( $_POST[ 'regi_first_name' ] ) );
    }
    if ( isset( $_POST[ 'regi_last_name' ] ) ) {
        update_user_meta( $customer_id, 'last_name', wc_clean( $_POST[ 'regi_last_name' ] ) );
    }
}

add_action( 'woocommerce_after_add_to_cart_form', 'add_custom_form_product_details' );
function add_custom_form_product_details(){
    echo '<div class="msg_seller_form"><button class="btn-msg-seller popmake-773">Message Seller</button></div>';
}

add_action('woocommerce_register_form_start', function() {
    acf_form([
        'form' => false,
        'field_groups' => [974],
    ]);
});

add_action('woocommerce_created_customer', function($customer_id) {
    if (!empty($_POST['acf'])) {
        foreach ($_POST['acf'] as $key => $value) {
            update_field($key, $value, 'user_' . $customer_id);
        }
    }
});

add_action('woocommerce_edit_account_form', function() {
    acf_form([
        'post_id' => 'user_' . get_current_user_id(),
        'form' => false,
        'field_groups' => [974],
    ]);
});

add_action('woocommerce_save_account_details', function($user_id) {
    if (!empty($_POST['acf'])) {
        foreach ($_POST['acf'] as $key => $value) {
            update_field($key, $value, 'user_' . $user_id);
        }
    }
}, 12);

/*add_action('woocommerce_register_post', function($username, $email, $validation_errors) {
    if (empty($_POST['acf']['regi_company_name'])) {
        $validation_errors->add('acf_field_error', __('Company name is a required field.', 'textdomain'));
    }
    if (empty($_POST['acf']['regi_office_phone'])) {
        $validation_errors->add('acf_field_error', __('Office phone is a required field.', 'textdomain'));
    }
}, 10, 3);*/

function woo_categories_filter_shortcodes(){
    ob_start();
    if(is_product_category()){
		$woocat = get_queried_object();
		if(!empty($woocat) && $woocat->count > 0){
    		if($woocat->term_id == 23 || $woocat->parent == 23){
    			echo do_shortcode('[wpf-filters id=1]');
    		} else if($woocat->term_id == 46 || $woocat->parent == 46){
    		    echo do_shortcode('[wpf-filters id=4]');
    		} else if($woocat->term_id == 147 || $woocat->parent == 147){
    		    echo do_shortcode('[wpf-filters id=5]');
    		} else if($woocat->term_id == 22 || $woocat->parent == 22){
    		    echo do_shortcode('[wpf-filters id=6]');
    		} else if($woocat->term_id == 18 || $woocat->parent == 18){
    		    echo do_shortcode('[wpf-filters id=7]');
    		} else if($woocat->term_id == 45 || $woocat->parent == 45){
    		    echo do_shortcode('[wpf-filters id=8]');
    		} else if($woocat->term_id == 24 || $woocat->parent == 24){
    		    echo do_shortcode('[wpf-filters id=9]');
    		} else if($woocat->term_id == 19 || $woocat->parent == 19){
    		    echo do_shortcode('[wpf-filters id=10]');
    		} else if($woocat->term_id == 20 || $woocat->parent == 20){
    		    echo do_shortcode('[wpf-filters id=11]');
    		} else if($woocat->term_id == 21 || $woocat->parent == 21){
    		    echo do_shortcode('[wpf-filters id=12]');
    		} else if($woocat->term_id == 209 || $woocat->parent == 209){
    		    echo do_shortcode('[wpf-filters id=14]');
    		}
		}
	}
    return ob_get_clean();
}
add_shortcode('WOO_CATEGORIES_FILTERS','woo_categories_filter_shortcodes');